package com.qmth.cqb.paper.service;

import java.util.Map;

import com.qmth.cqb.paper.model.ExtractConfig;
import com.qmth.cqb.paper.model.Paper;

/**
 * 
 * @author  	chenken
 * @date    	2017年4月14日 下午6:08:15
 * @company 	QMTH
 * @description 调卷规则接口
 */
public interface ExtractConfigService {
	/**
	 * 根据考试ID和课程code获取规则
	 * @param examId
	 * @param courseCode
	 * @return
	 */
	public ExtractConfig findConfig(ExtractConfig extractConfig);
	/**
	 * 根据ID获取调卷规则
	 * @param id
	 * @return
	 */
	public ExtractConfig findConfigById(String id);
	/**
	 * 保存调卷规则
	 */
	public void saveExtractConfig(ExtractConfig extractConfig);
	/**
	 * 按照设定调卷规则规则生成一套试卷
	 * @param examId
	 * @param courseCode
	 * @param groupCode
	 * @return
	 */
	public Map<String, String> makePaperByConfig(String extractConfigId);
	/**
	 * 重组试卷，生成新的试卷
	 * @param paper					选中的试卷
	 * @param upSetQuestionOrder	小题乱序		1:乱序  0：不乱序
	 * @param upSetOptionOrder		选项乱序		1:乱序  0：不乱序
	 * @return
	 */
	public Paper recombinationPaper(Paper paper,int upSetQuestionOrder,int upSetOptionOrder);
}
